
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535L
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535L
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x1A:
	.DB  0x81,0xF3,0x49,0x61,0x33,0x25,0x5,0xF1
	.DB  0x81,0x21,0xD,0x5F,0xFF

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x0D
	.DW  _sym
	.DW  _0x1A*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 03.10.2010
;Author  : NeVaDa
;Company : Microsoft
;Comments:
;
;
;Chip type               : ATmega8535L
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 128
;*****************************************************/
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;
;// 1 Wire Bus functions
;#asm
   .equ __w1_port=0x18 ;PORTB
   .equ __w1_bit=4
; 0000 0020 #endasm
;#include <1wire.h>
;#include <ds1820.h>
;#define MAX_DS1820 8
;volatile unsigned char ds1820_devices;
;volatile unsigned char ds1820_rom_codes[MAX_DS1820][9];
;volatile unsigned char start1;//   5   
;volatile unsigned char soft_start;//  
;eeprom volatile unsigned char rejim=0;//       0  ,
;                                    //1   
;                                    //2  
;                                    //3   
;eeprom volatile unsigned char zadanie_U=0; //    
;eeprom volatile unsigned char zadanie_I=0; //    
;volatile unsigned char izmerenoe_U;//        
;volatile unsigned char izmerenoe_I;//        
;bit start;//    0==    1== 
;/********************************* ***************************************************************/
;void start_310 (void){//       
; 0000 0032 void start_310 (void){

	.CSEG
_start_310:
; 0000 0033 delay_ms (2000);      // 2       
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0034 PORTB.0=1;            //   
	SBI  0x18,0
; 0000 0035 if (zadanie_U==0){    //    0
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	BRNE _0x5
; 0000 0036 zadanie_U=1;          //    
	RCALL SUBOPT_0x0
	LDI  R30,LOW(1)
	RCALL __EEPROMWRB
; 0000 0037 }
; 0000 0038 if (zadanie_I==0){    //    0
_0x5:
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x1
	BRNE _0x6
; 0000 0039 zadanie_I=1;          //    
	RCALL SUBOPT_0x2
	LDI  R30,LOW(1)
	RCALL __EEPROMWRB
; 0000 003A }
; 0000 003B delay_ms (500);       // 0,5 
_0x6:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 003C TCCR2=0x6C;           //  2    
	LDI  R30,LOW(108)
	OUT  0x25,R30
; 0000 003D }
	RET
;/*******************************************************************************************************************/
;/*************************************   250 *****************************************************/
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0041 {
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0042 start1++;
	LDS  R30,_start1
	SUBI R30,-LOW(1)
	STS  _start1,R30
; 0000 0043 if (start1==5){// start1  ==5
	LDS  R26,_start1
	CPI  R26,LOW(0x5)
	BRNE _0x7
; 0000 0044 soft_start++;  //  soft_start  1
	LDS  R30,_soft_start
	SUBI R30,-LOW(1)
	STS  _soft_start,R30
; 0000 0045 start1=0;      // start1
	LDI  R30,LOW(0)
	STS  _start1,R30
; 0000 0046 }
; 0000 0047 if (rejim==0 || rejim==1 & soft_start<zadanie_I){//         
_0x7:
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x1
	BREQ _0x9
	LDI  R26,LOW(1)
	RCALL __EQB12
	MOV  R0,R30
	RCALL SUBOPT_0x4
	LDS  R26,_soft_start
	RCALL __LTB12U
	AND  R30,R0
	BREQ _0x8
_0x9:
; 0000 0048 OCR2=soft_start;                                 //  
	LDS  R30,_soft_start
	OUT  0x23,R30
; 0000 0049 }
; 0000 004A if (rejim==2 || rejim==3 && soft_start<zadanie_U){//         
_0x8:
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0x2)
	BREQ _0xC
	CPI  R30,LOW(0x3)
	BRNE _0xD
	RCALL SUBOPT_0x6
	LDS  R26,_soft_start
	CP   R26,R30
	BRLO _0xC
_0xD:
	RJMP _0xB
_0xC:
; 0000 004B OCR2=soft_start;                                 //  
	LDS  R30,_soft_start
	OUT  0x23,R30
; 0000 004C }
; 0000 004D if (OCR2==zadanie_I || OCR2==zadanie_U){//      
_0xB:
	IN   R0,35
	RCALL SUBOPT_0x4
	CP   R30,R0
	BREQ _0x11
	IN   R0,35
	RCALL SUBOPT_0x6
	CP   R30,R0
	BRNE _0x10
_0x11:
; 0000 004E TIMSK=0x01;//      2      0 "00000001"
	LDI  R30,LOW(1)
	OUT  0x39,R30
; 0000 004F TCCR0=0x03;//   0         250 
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 0050 }
; 0000 0051 start=1;//   
_0x10:
	SET
	BLD  R2,0
; 0000 0052 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;/*******************************************************************************************************************/
;/****************************  0 250 ***********************************************************/
;volatile unsigned int divider_1000;//  1000 250
;volatile long int divider_125000;//  125000 0,5
;volatile unsigned int divider_2500;//  2500 100
;interrupt [TIM0_OVF] void timer0_ovf_isr(void){
; 0000 0058 interrupt [10] void timer0_ovf_isr(void){
_timer0_ovf_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0059 divider_1000++;
	LDI  R26,LOW(_divider_1000)
	LDI  R27,HIGH(_divider_1000)
	RCALL SUBOPT_0x7
; 0000 005A if (divider_1000==1000){
	RCALL SUBOPT_0x8
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRNE _0x13
; 0000 005B divider_1000=0;
	LDI  R30,LOW(0)
	STS  _divider_1000,R30
	STS  _divider_1000+1,R30
; 0000 005C }
; 0000 005D divider_125000++;
_0x13:
	LDI  R26,LOW(_divider_125000)
	LDI  R27,HIGH(_divider_125000)
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
; 0000 005E if (divider_125000==125000){
	LDS  R26,_divider_125000
	LDS  R27,_divider_125000+1
	LDS  R24,_divider_125000+2
	LDS  R25,_divider_125000+3
	__CPD2N 0x1E848
	BRNE _0x14
; 0000 005F divider_125000=0;
	LDI  R30,LOW(0)
	STS  _divider_125000,R30
	STS  _divider_125000+1,R30
	STS  _divider_125000+2,R30
	STS  _divider_125000+3,R30
; 0000 0060 }
; 0000 0061 divider_2500++;
_0x14:
	LDI  R26,LOW(_divider_2500)
	LDI  R27,HIGH(_divider_2500)
	RCALL SUBOPT_0x7
; 0000 0062 if (divider_2500==2500){
	RCALL SUBOPT_0x9
	CPI  R26,LOW(0x9C4)
	LDI  R30,HIGH(0x9C4)
	CPC  R27,R30
	BRNE _0x15
; 0000 0063 divider_2500=0;
	LDI  R30,LOW(0)
	STS  _divider_2500,R30
	STS  _divider_2500+1,R30
; 0000 0064 }
; 0000 0065 }
_0x15:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;/*******************************************************************************************************************/
;/*************************************   *******************************************
;interrupt [ANA_COMP] void ana_comp_isr(void){//    
;TCCR2=0x00;                                  //  2  
;start=0;                                     // 
;}
;*******************************************************************************************************************/
;/****************************************************************************************************************/
;//  ADC6  
;void ADC_I (void){ //  ADC6
; 0000 006F void ADC_I (void){
_ADC_I:
; 0000 0070 volatile unsigned char calculator_bufer_I[4]={0,0,0,0};//   
; 0000 0071 ADMUX=0b00100110;
	RCALL SUBOPT_0xA
;	calculator_bufer_I -> Y+0
	LDI  R30,LOW(38)
	RCALL SUBOPT_0xB
; 0000 0072 ADCSRA=0b11000111;
; 0000 0073 calculator_bufer_I[3]=calculator_bufer_I[2];
; 0000 0074 calculator_bufer_I[2]=calculator_bufer_I[1];
; 0000 0075 calculator_bufer_I[1]=calculator_bufer_I[0];
; 0000 0076 calculator_bufer_I[0]=ADCH;
; 0000 0077 izmerenoe_I=(calculator_bufer_I[3]+calculator_bufer_I[2]+calculator_bufer_I[1]+calculator_bufer_I[0])/4;
	STS  _izmerenoe_I,R30
; 0000 0078 }
	RJMP _0x2020001
;//  ADC7  
;void ADC_U (void){ //  ADC7
; 0000 007A void ADC_U (void){
_ADC_U:
; 0000 007B volatile unsigned char calculator_bufer_U[4]={0,0,0,0};//   
; 0000 007C ADMUX=0b00100111;
	RCALL SUBOPT_0xA
;	calculator_bufer_U -> Y+0
	LDI  R30,LOW(39)
	RCALL SUBOPT_0xB
; 0000 007D ADCSRA=0b11000111;
; 0000 007E calculator_bufer_U[3]=calculator_bufer_U[2];
; 0000 007F calculator_bufer_U[2]=calculator_bufer_U[1];
; 0000 0080 calculator_bufer_U[1]=calculator_bufer_U[0];
; 0000 0081 calculator_bufer_U[0]=ADCH;
; 0000 0082 izmerenoe_U=(calculator_bufer_U[3]+calculator_bufer_U[2]+calculator_bufer_U[1]+calculator_bufer_U[0])/4;
	STS  _izmerenoe_U,R30
; 0000 0083 }
	RJMP _0x2020001
;/*******************************************************************************************************************/
;/******************************************** ***********************************************************/
;// 
;void PWM_control_I (void){
; 0000 0087 void PWM_control_I (void){
_PWM_control_I:
; 0000 0088 volatile unsigned char control_I;//      
; 0000 0089 control_I=izmerenoe_I;
	SBIW R28,1
;	control_I -> Y+0
	LDS  R30,_izmerenoe_I
	ST   Y,R30
; 0000 008A if (izmerenoe_I < zadanie_I){
	RCALL SUBOPT_0x4
	LDS  R26,_izmerenoe_I
	CP   R26,R30
	BRSH _0x16
; 0000 008B control_I++;
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
; 0000 008C OCR2=control_I;
	OUT  0x23,R30
; 0000 008D }
; 0000 008E if (izmerenoe_I > zadanie_I){
_0x16:
	RCALL SUBOPT_0x4
	LDS  R26,_izmerenoe_I
	CP   R30,R26
	BRSH _0x17
; 0000 008F control_I--;
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   Y,R30
; 0000 0090 OCR2=control_I;
	OUT  0x23,R30
; 0000 0091 }
; 0000 0092 }
_0x17:
	ADIW R28,1
	RET
;// 
;void PWM_control_U (void){
; 0000 0094 void PWM_control_U (void){
; 0000 0095 volatile unsigned char control_U;//      
; 0000 0096 control_U=izmerenoe_U;
;	control_U -> Y+0
; 0000 0097 if (izmerenoe_U < zadanie_U){
; 0000 0098 control_U++;
; 0000 0099 OCR2=control_U;
; 0000 009A }
; 0000 009B if (izmerenoe_U > zadanie_I){
; 0000 009C control_U--;
; 0000 009D OCR2=control_U;
; 0000 009E }
; 0000 009F }
;/*******************************************************************************************************************/
;/******************************************* **************************************************/
;/*********************   *******
;              a
;            -----
;          f|     |b
;           |  g  |
;            -----
;          e|     |c
;           |  d  |
;            ----- *h
;g      f      e      d      c      b      a      in
;p7    p6    p5    p4    p3    p2    p1    p0
;**********************************************************************/
;#define dig1I PORTA.0//PORTD.5         dig1
;#define dig2I PORTA.1//PORTD.6         dig2
;#define dig3I PORTA.2//PORTD.7        dig3
;#define dig1U PORTA.3//PORTD.5         dig1
;#define dig2U PORTA.4//PORTD.6         dig2
;#define dig3U PORTA.5//PORTD.7        dig3
;unsigned char sym[]={
;0b10000001, //(0)0
;0b11110011, //(1)1
;0b01001001, //(2)2
;0b01100001, //(3)3
;0b00110011, //(4)4
;0b00100101, //(5)5
;0b00000101, //(6)6
;0b11110001, //(7)7
;0b10000001, //(8)8
;0b00100001, //(9)9
;0b00001101, //(10)E
;0b01011111, //(11)r
;0b11111111  //(12)  
;};

	.DSEG
;
;volatile unsigned char indy_I;//         
;volatile unsigned char indy_U;//         
;volatile unsigned char cur_dig;//  
;volatile unsigned char sym_out[6];// sym_out   ( 6)        
;/*****************************************************************/
;void recoding (void){
; 0000 00C9 void recoding (void){

	.CSEG
_recoding:
; 0000 00CA /****************** *****************************/
; 0000 00CB volatile unsigned char indy_static_I;//         
; 0000 00CC volatile unsigned char indy_static_U;//         
; 0000 00CD indy_static_I=indy_I;
	SBIW R28,2
;	indy_static_I -> Y+1
;	indy_static_U -> Y+0
	LDS  R30,_indy_I
	STD  Y+1,R30
; 0000 00CE indy_static_U=indy_U;
	LDS  R30,_indy_U
	ST   Y,R30
; 0000 00CF if (indy_static_I<255){//  indication  255
	LDD  R26,Y+1
	CPI  R26,LOW(0xFF)
	BRSH _0x1B
; 0000 00D0 indy_I=izmerenoe_I;             //indy_I  izmerenoe_I  divider_1000  1
	LDS  R30,_izmerenoe_I
	RCALL SUBOPT_0xC
; 0000 00D1 sym_out[0]=indy_I%10;           //  sym_out 0       
	STS  _sym_out,R30
; 0000 00D2 indy_I=indy_I/10;             //  indication      380  38
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xC
; 0000 00D3 sym_out[1]=indy_I%10;           //  8   
	__PUTB1MN _sym_out,1
; 0000 00D4 indy_I=indy_I/10;             // 38  3
	RCALL SUBOPT_0xD
	STS  _indy_I,R30
; 0000 00D5 sym_out[2]=indy_I;              //    3
	LDS  R30,_indy_I
	RJMP _0xD0
; 0000 00D6 }
; 0000 00D7 else                              // 
_0x1B:
; 0000 00D8 {
; 0000 00D9 sym_out[0]=11;                   //
	LDI  R30,LOW(11)
	STS  _sym_out,R30
; 0000 00DA sym_out[1]=10;                   //Er
	LDI  R30,LOW(10)
	__PUTB1MN _sym_out,1
; 0000 00DB sym_out[2]=12;                   // 0   
	LDI  R30,LOW(12)
_0xD0:
	__PUTB1MN _sym_out,2
; 0000 00DC }
; 0000 00DD /****************** **********************/
; 0000 00DE if (indy_static_U<255){  //  indication  255
	LD   R26,Y
	CPI  R26,LOW(0xFF)
	BRSH _0x1D
; 0000 00DF indy_U=izmerenoe_U;      //indy_U  izmerenoe_U
	LDS  R30,_izmerenoe_U
	RCALL SUBOPT_0xE
; 0000 00E0 sym_out[3]=indy_U%10;    //  sym_out 0       
	__PUTB1MN _sym_out,3
; 0000 00E1 indy_U=indy_U/10;        //  indication      380  38
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0xE
; 0000 00E2 sym_out[4]=indy_U%10;    //  8   
	__PUTB1MN _sym_out,4
; 0000 00E3 indy_U=indy_U/10;        // 38  3
	RCALL SUBOPT_0xF
	STS  _indy_U,R30
; 0000 00E4 sym_out[5]=indy_U;       //    3
	LDS  R30,_indy_U
	RJMP _0xD1
; 0000 00E5 }
; 0000 00E6 else                     // 
_0x1D:
; 0000 00E7 {
; 0000 00E8 sym_out[3]=11;           //
	LDI  R30,LOW(11)
	__PUTB1MN _sym_out,3
; 0000 00E9 sym_out[4]=10;           //Er
	LDI  R30,LOW(10)
	__PUTB1MN _sym_out,4
; 0000 00EA sym_out[5]=12;           // 0   
	LDI  R30,LOW(12)
_0xD1:
	__PUTB1MN _sym_out,5
; 0000 00EB }
; 0000 00EC 
; 0000 00ED /**********     ********************/
; 0000 00EE PORTB=sym[12];                                                         //  B
	__GETB1MN _sym,12
	OUT  0x18,R30
; 0000 00EF switch (cur_dig){                                                      //   
	RCALL SUBOPT_0x10
; 0000 00F0 case 0:{dig1I=1; dig2I=0; dig3I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    1 
	SBIW R30,0
	BRNE _0x22
	SBI  0x1B,0
	CBI  0x1B,1
	CBI  0x1B,2
	RCALL SUBOPT_0x11
	RJMP _0x21
; 0000 00F1 case 1:{dig2I=1; dig3I=0; dig1I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    2 
_0x22:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2F
	SBI  0x1B,1
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x11
	RJMP _0x21
; 0000 00F2 case 2:{dig3I=1; dig1I=0; dig2I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    3 
_0x2F:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x3C
	SBI  0x1B,2
	CBI  0x1B,0
	CBI  0x1B,1
	RCALL SUBOPT_0x11
	RJMP _0x21
; 0000 00F3 case 3:{dig1U=1; dig3I=0; dig1I=0; dig2I=0; dig2U=0; dig3U=0; break;}; //    1 
_0x3C:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x49
	SBI  0x1B,3
	RCALL SUBOPT_0x12
	CBI  0x1B,1
	CBI  0x1B,4
	CBI  0x1B,5
	RJMP _0x21
; 0000 00F4 case 4:{dig2U=1; dig1U=0; dig3I=0; dig1I=0; dig2I=0; dig3U=0; break;}; //    2 
_0x49:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x56
	SBI  0x1B,4
	CBI  0x1B,3
	RCALL SUBOPT_0x12
	CBI  0x1B,1
	CBI  0x1B,5
	RJMP _0x21
; 0000 00F5 case 5:{dig3U=1; dig2U=0; dig1U=0; dig3I=0; dig1I=0; dig2I=0; break;}; //    3 
_0x56:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x21
	SBI  0x1B,5
	CBI  0x1B,4
	CBI  0x1B,3
	RCALL SUBOPT_0x12
	CBI  0x1B,1
; 0000 00F6 }
_0x21:
; 0000 00F7 
; 0000 00F8 if (indy_static_I<10){                 //  adc_dataI<10
	LDD  R26,Y+1
	CPI  R26,LOW(0xA)
	BRSH _0x70
; 0000 00F9 dig2I=0; dig1I=0;                          // 2  
	CBI  0x1B,1
	CBI  0x1B,0
; 0000 00FA }
; 0000 00FB if (indy_static_I<100){                //  adc_dataI<100
_0x70:
	LDD  R26,Y+1
	CPI  R26,LOW(0x64)
	BRSH _0x75
; 0000 00FC dig2I=0;                                   // 1  
	CBI  0x1B,1
; 0000 00FD }
; 0000 00FE if (indy_static_U<10){                //  adc_dataI<10
_0x75:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRSH _0x78
; 0000 00FF dig2U=0; dig1U=0;                         // 2  
	CBI  0x1B,4
	CBI  0x1B,3
; 0000 0100 }
; 0000 0101 if (indy_static_U<100){               //  adc_dataI<100
_0x78:
	LD   R26,Y
	CPI  R26,LOW(0x64)
	BRSH _0x7D
; 0000 0102 dig2U=0;                                  // 1  
	CBI  0x1B,4
; 0000 0103 }
; 0000 0104 if (divider_1000==1 || divider_1000==501){
_0x7D:
	RCALL SUBOPT_0x8
	SBIW R26,1
	BREQ _0x81
	RCALL SUBOPT_0x8
	CPI  R26,LOW(0x1F5)
	LDI  R30,HIGH(0x1F5)
	CPC  R27,R30
	BRNE _0x80
_0x81:
; 0000 0105 PORTB=sym[sym_out[cur_dig]];              //      
	RCALL SUBOPT_0x10
	SUBI R30,LOW(-_sym_out)
	SBCI R31,HIGH(-_sym_out)
	LD   R30,Z
	RCALL SUBOPT_0x13
	SUBI R30,LOW(-_sym)
	SBCI R31,HIGH(-_sym)
	LD   R30,Z
	OUT  0x18,R30
; 0000 0106 cur_dig=cur_dig+1;                        //  cur_dig  1
	LDS  R30,_cur_dig
	SUBI R30,-LOW(1)
	STS  _cur_dig,R30
; 0000 0107 if (cur_dig==5){
	LDS  R26,_cur_dig
	CPI  R26,LOW(0x5)
	BRNE _0x83
; 0000 0108  cur_dig=0;                               //  cur_dig     3
	LDI  R30,LOW(0)
	STS  _cur_dig,R30
; 0000 0109 }
; 0000 010A }
_0x83:
; 0000 010B }
_0x80:
	ADIW R28,2
	RET
;/*******************************************************************************************************************/
;/*************************************************************************************************************/
;void button (void){
; 0000 010E void button (void){
_button:
; 0000 010F #define b_bolshe PORTD.0                                       // 
; 0000 0110 #define b_menshe PORTD.1                                       // 
; 0000 0111 #define b_rejim PORTD.2                                        //  
; 0000 0112 #define b_parametr PORTD.3                                     //  
; 0000 0113 float koficient;                                               //      
; 0000 0114 if (divider_2500==1){                                          //  100    
	SBIW R28,4
;	koficient -> Y+0
	RCALL SUBOPT_0x9
	SBIW R26,1
	BREQ PC+2
	RJMP _0x84
; 0000 0115 if (b_bolshe==0 || b_menshe==0 || b_rejim==0 || b_parametr==0){//    
	RCALL SUBOPT_0x14
	BREQ _0x86
	RCALL SUBOPT_0x15
	BREQ _0x86
	RCALL SUBOPT_0x16
	BREQ _0x86
	LDI  R26,0
	SBIC 0x12,3
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x85
_0x86:
; 0000 0116 TCCR2=0x00;                                                    //  2  
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 0117 }
; 0000 0118 if (b_rejim==0 && b_bolshe==0 && b_menshe==1 && b_parametr==1){   //    
_0x85:
	RCALL SUBOPT_0x16
	BRNE _0x89
	RCALL SUBOPT_0x14
	BRNE _0x89
	SBIS 0x12,1
	RJMP _0x89
	SBIC 0x12,3
	RJMP _0x8A
_0x89:
	RJMP _0x88
_0x8A:
; 0000 0119 rejim++;                                                       //   
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x17
; 0000 011A if (rejim==3){                                                 // 
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0x3)
	BRNE _0x8B
; 0000 011B rejim=0;                                                       //   3 
	RCALL SUBOPT_0x3
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
; 0000 011C }
; 0000 011D }
_0x8B:
; 0000 011E if (b_bolshe==0 && b_menshe==1 && b_rejim==1 && b_parametr==1 && rejim==0 || rejim==1){//         
_0x88:
	RCALL SUBOPT_0x14
	BRNE _0x8D
	SBIS 0x12,1
	RJMP _0x8D
	SBIS 0x12,2
	RJMP _0x8D
	SBIS 0x12,3
	RJMP _0x8D
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x1
	BREQ _0x8F
_0x8D:
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0x1)
	BRNE _0x8C
_0x8F:
; 0000 011F zadanie_I++;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x17
; 0000 0120 koficient=zadanie_I/1,275;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x18
; 0000 0121 indy_I=(unsigned char)koficient;
; 0000 0122 }
; 0000 0123 if (b_menshe==0 && b_bolshe==0 && b_parametr==1 && b_rejim==1 && rejim==0 || rejim==1){//         
_0x8C:
	RCALL SUBOPT_0x15
	BRNE _0x92
	RCALL SUBOPT_0x14
	BRNE _0x92
	SBIS 0x12,3
	RJMP _0x92
	SBIS 0x12,2
	RJMP _0x92
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x1
	BREQ _0x94
_0x92:
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0x1)
	BRNE _0x91
_0x94:
; 0000 0124 zadanie_I--;
	RCALL SUBOPT_0x4
	SUBI R30,LOW(1)
	RCALL __EEPROMWRB
	SUBI R30,-LOW(1)
; 0000 0125 koficient=zadanie_I/1,275;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x18
; 0000 0126 indy_I=(unsigned char)koficient;
; 0000 0127 }
; 0000 0128 if (b_bolshe==0 && b_menshe==1 && b_rejim==1 && b_parametr==1 && rejim==2 || rejim==3){//         
_0x91:
	RCALL SUBOPT_0x14
	BRNE _0x97
	SBIS 0x12,1
	RJMP _0x97
	SBIS 0x12,2
	RJMP _0x97
	SBIS 0x12,3
	RJMP _0x97
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0x2)
	BREQ _0x99
_0x97:
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0x3)
	BRNE _0x96
_0x99:
; 0000 0129 zadanie_U++;
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x17
; 0000 012A koficient=zadanie_U/1,275;
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x19
; 0000 012B indy_U=(unsigned char)koficient;
; 0000 012C }
; 0000 012D if (b_menshe==0 && b_bolshe==0 && b_parametr==1 && b_rejim==1 && rejim==2 || rejim==3){//         
_0x96:
	RCALL SUBOPT_0x15
	BRNE _0x9C
	RCALL SUBOPT_0x14
	BRNE _0x9C
	SBIS 0x12,3
	RJMP _0x9C
	SBIS 0x12,2
	RJMP _0x9C
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0x2)
	BREQ _0x9E
_0x9C:
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0x3)
	BRNE _0x9B
_0x9E:
; 0000 012E zadanie_U--;
	RCALL SUBOPT_0x6
	SUBI R30,LOW(1)
	RCALL __EEPROMWRB
	SUBI R30,-LOW(1)
; 0000 012F koficient=zadanie_U/1,275;
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x19
; 0000 0130 indy_U=(unsigned char)koficient;
; 0000 0131 }
; 0000 0132 }
_0x9B:
; 0000 0133 }
_0x84:
_0x2020001:
	ADIW R28,4
	RET
;/*******************************************************************************************************************/
;/**********************************************************************************************************/
;#define l_pad PORTD.4
;#define l_pad_pulse PORTD.5
;#define l_jest PORTD.6
;#define l_jest_pulse PORTD.6
;#define l_alarm PORTB.7
;void led_rejim (void){
; 0000 013B void led_rejim (void){
_led_rejim:
; 0000 013C switch (rejim){
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x13
; 0000 013D case 0:{l_pad=0; l_pad_pulse=1; l_jest=1; l_jest_pulse=1;};
	SBIW R30,0
	BRNE _0xA3
	CBI  0x12,4
	SBI  0x12,5
	SBI  0x12,6
	SBI  0x12,6
; 0000 013E case 1:{l_pad_pulse=0; l_pad=1; l_jest=1; l_jest_pulse=1;};
	RJMP _0xAC
_0xA3:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xAD
_0xAC:
	CBI  0x12,5
	SBI  0x12,4
	SBI  0x12,6
	SBI  0x12,6
; 0000 013F case 2:{l_jest=0; l_pad_pulse=1; l_pad=1; l_jest_pulse=1;};
	RJMP _0xB6
_0xAD:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xB7
_0xB6:
	CBI  0x12,6
	SBI  0x12,5
	SBI  0x12,4
	SBI  0x12,6
; 0000 0140 case 3:{l_jest_pulse=0; l_jest=1; l_pad_pulse=1; l_pad=1;};
	RJMP _0xC0
_0xB7:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0xA2
_0xC0:
	CBI  0x12,6
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x12,4
; 0000 0141 }
_0xA2:
; 0000 0142 }
	RET
;/*******************************************************************************************************************/
;
;void main(void)
; 0000 0146 {
_main:
; 0000 0147 // Declare your local variables here
; 0000 0148 
; 0000 0149 // Input/Output Ports initialization
; 0000 014A // Port A initialization
; 0000 014B // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 014C // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 014D PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 014E DDRA=0x3F;
	LDI  R30,LOW(63)
	OUT  0x1A,R30
; 0000 014F 
; 0000 0150 // Port B initialization
; 0000 0151 // Func7=Out Func6=Out Func5=Out Func4=In Func3=In Func2=Out Func1=Out Func0=Out
; 0000 0152 // State7=0 State6=0 State5=0 State4=T State3=T State2=0 State1=0 State0=0
; 0000 0153 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0154 DDRB=0xE7;
	LDI  R30,LOW(231)
	OUT  0x17,R30
; 0000 0155 
; 0000 0156 // Port C initialization
; 0000 0157 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0158 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 0159 PORTC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x15,R30
; 0000 015A DDRC=0xFF;
	OUT  0x14,R30
; 0000 015B 
; 0000 015C // Port D initialization
; 0000 015D // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 015E // State7=0 State6=1 State5=1 State4=1 State3=P State2=P State1=P State0=P
; 0000 015F PORTD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x12,R30
; 0000 0160 DDRD=0xF0;
	LDI  R30,LOW(240)
	OUT  0x11,R30
; 0000 0161 
; 0000 0162 // Timer/Counter 0 initialization
; 0000 0163 // Clock source: System Clock
; 0000 0164 // Clock value: Timer 0 Stopped
; 0000 0165 // Mode: Normal top=FFh
; 0000 0166 // OC0 output: Disconnected
; 0000 0167 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0168 TCNT0=0x00;
	OUT  0x32,R30
; 0000 0169 OCR0=0x00;
	OUT  0x3C,R30
; 0000 016A 
; 0000 016B // Timer/Counter 1 initialization
; 0000 016C // Clock source: System Clock
; 0000 016D // Clock value: Timer1 Stopped
; 0000 016E // Mode: Normal top=FFFFh
; 0000 016F // OC1A output: Discon.
; 0000 0170 // OC1B output: Discon.
; 0000 0171 // Noise Canceler: Off
; 0000 0172 // Input Capture on Falling Edge
; 0000 0173 // Timer1 Overflow Interrupt: Off
; 0000 0174 // Input Capture Interrupt: Off
; 0000 0175 // Compare A Match Interrupt: Off
; 0000 0176 // Compare B Match Interrupt: Off
; 0000 0177 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0178 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0179 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 017A TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 017B ICR1H=0x00;
	OUT  0x27,R30
; 0000 017C ICR1L=0x00;
	OUT  0x26,R30
; 0000 017D OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 017E OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 017F OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0180 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0181 
; 0000 0182 // Timer/Counter 2 initialization
; 0000 0183 // Clock source: System Clock
; 0000 0184 // Clock value: Timer2 Stopped
; 0000 0185 // Mode: Normal top=FFh
; 0000 0186 // OC2 output: Disconnected
; 0000 0187 ASSR=0x00;
	OUT  0x22,R30
; 0000 0188 TCCR2=0x00;
	OUT  0x25,R30
; 0000 0189 TCNT2=0x00;
	OUT  0x24,R30
; 0000 018A OCR2=0x00;
	OUT  0x23,R30
; 0000 018B 
; 0000 018C // External Interrupt(s) initialization
; 0000 018D // INT0: Off
; 0000 018E // INT1: Off
; 0000 018F // INT2: Off
; 0000 0190 MCUCR=0x00;
	OUT  0x35,R30
; 0000 0191 MCUCSR=0x00;
	OUT  0x34,R30
; 0000 0192 
; 0000 0193 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0194 TIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x39,R30
; 0000 0195 
; 0000 0196 // Analog Comparator initialization
; 0000 0197 // Analog Comparator: On
; 0000 0198 // The Analog Comparator's positive input is
; 0000 0199 // connected to the Bandgap Voltage Reference
; 0000 019A // Interrupt on Falling Output Edge
; 0000 019B // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 019C //ACSR=0x4A;
; 0000 019D ACSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 019E SFIOR=0x00;
	OUT  0x30,R30
; 0000 019F 
; 0000 01A0 /*** ADC initialization
; 0000 01A1 // ADC Clock frequency: 1000,000 kHz
; 0000 01A2 // ADC Voltage Reference: AREF pin
; 0000 01A3 // ADC High Speed Mode: Off
; 0000 01A4 // ADC Auto Trigger Source: Free Running
; 0000 01A5 // Only the 8 most significant bits of
; 0000 01A6 // the AD conversion result are used
; 0000 01A7 ADMUX=ADC_VREF_TYPE & 0xff;
; 0000 01A8 ADCSRA=0xA4;
; 0000 01A9 SFIOR&=0x0F;
; 0000 01AA ***/
; 0000 01AB // Determine the number of DS1820 devices
; 0000 01AC // connected to the 1 Wire bus
; 0000 01AD ds1820_devices=w1_search(0xf0,ds1820_rom_codes);
	LDI  R30,LOW(240)
	ST   -Y,R30
	LDI  R30,LOW(_ds1820_rom_codes)
	LDI  R31,HIGH(_ds1820_rom_codes)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _w1_search
	STS  _ds1820_devices,R30
; 0000 01AE 
; 0000 01AF // Global enable interrupts
; 0000 01B0 #asm("sei")
	sei
; 0000 01B1 /*******************************************************************************************************************/
; 0000 01B2 start_310();
	RCALL _start_310
; 0000 01B3 while (start!=0 && rejim==0){//       
_0xCA:
	LDI  R26,0
	SBRC R2,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0xCD
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x1
	BREQ _0xCE
_0xCD:
	RJMP _0xCC
_0xCE:
; 0000 01B4 ADC_I();                     //  
	RCALL _ADC_I
; 0000 01B5 PWM_control_I();             //    
	RCALL _PWM_control_I
; 0000 01B6 ADC_U();                     // 
	RCALL _ADC_U
; 0000 01B7 recoding ();                 //  
	RCALL _recoding
; 0000 01B8 button();                    // 
	RCALL _button
; 0000 01B9 led_rejim();                 //     
	RCALL _led_rejim
; 0000 01BA }
	RJMP _0xCA
_0xCC:
; 0000 01BB 
; 0000 01BC 
; 0000 01BD 
; 0000 01BE 
; 0000 01BF 
; 0000 01C0 
; 0000 01C1 
; 0000 01C2 
; 0000 01C3 
; 0000 01C4 }
_0xCF:
	RJMP _0xCF

	.CSEG

	.DSEG
___ds1820_scratch_pad:
	.BYTE 0x9
_ds1820_devices:
	.BYTE 0x1
_ds1820_rom_codes:
	.BYTE 0x48
_start1:
	.BYTE 0x1
_soft_start:
	.BYTE 0x1

	.ESEG
_rejim:
	.DB  0x0
_zadanie_U:
	.DB  0x0
_zadanie_I:
	.DB  0x0

	.DSEG
_izmerenoe_U:
	.BYTE 0x1
_izmerenoe_I:
	.BYTE 0x1
_divider_1000:
	.BYTE 0x2
_divider_125000:
	.BYTE 0x4
_divider_2500:
	.BYTE 0x2
_sym:
	.BYTE 0xD
_indy_I:
	.BYTE 0x1
_indy_U:
	.BYTE 0x1
_cur_dig:
	.BYTE 0x1
_sym_out:
	.BYTE 0x6

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	LDI  R26,LOW(_zadanie_U)
	LDI  R27,HIGH(_zadanie_U)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	RCALL __EEPROMRDB
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2:
	LDI  R26,LOW(_zadanie_I)
	LDI  R27,HIGH(_zadanie_I)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3:
	LDI  R26,LOW(_rejim)
	LDI  R27,HIGH(_rejim)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	RCALL SUBOPT_0x2
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5:
	RCALL SUBOPT_0x3
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	RCALL SUBOPT_0x0
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	LDS  R26,_divider_1000
	LDS  R27,_divider_1000+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDS  R26,_divider_2500
	LDS  R27,_divider_2500+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xA:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0xB:
	OUT  0x7,R30
	LDI  R30,LOW(199)
	OUT  0x6,R30
	LDD  R30,Y+2
	STD  Y+3,R30
	LDD  R30,Y+1
	STD  Y+2,R30
	LD   R30,Y
	STD  Y+1,R30
	IN   R30,0x5
	ST   Y,R30
	LDD  R26,Y+3
	CLR  R27
	LDD  R30,Y+2
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,Y
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xC:
	STS  _indy_I,R30
	LDS  R26,_indy_I
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	LDS  R26,_indy_I
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE:
	STS  _indy_U,R30
	LDS  R26,_indy_U
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xF:
	LDS  R26,_indy_U
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	LDS  R30,_cur_dig
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	CBI  0x1B,3
	CBI  0x1B,4
	CBI  0x1B,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	CBI  0x1B,2
	CBI  0x1B,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x13:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x14:
	LDI  R26,0
	SBIC 0x12,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x15:
	LDI  R26,0
	SBIC 0x12,1
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	LDI  R26,0
	SBIC 0x12,2
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	SUBI R30,-LOW(1)
	RCALL __EEPROMWRB
	SUBI R30,LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x18:
	RCALL SUBOPT_0x13
	RCALL __CWD1
	RCALL __CDF1
	RCALL __PUTD1S0
	LDI  R30,LOW(275)
	LDI  R31,HIGH(275)
	RCALL __GETD1S0
	RCALL __CFD1U
	STS  _indy_I,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x19:
	RCALL SUBOPT_0x13
	RCALL __CWD1
	RCALL __CDF1
	RCALL __PUTD1S0
	LDI  R30,LOW(275)
	LDI  R31,HIGH(275)
	RCALL __GETD1S0
	RCALL __CFD1U
	STS  _indy_U,R30
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x780
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x4B
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USW 0x130
	sbis __w1_port-2,__w1_bit
	inc  r30
	__DELAY_USW 0x618
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xB
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x3B
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USW 0x140
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xB
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x45
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USW 0x12C
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x1B
	set
	ret

_w1_write:
	ldi  r22,8
	ld   r23,y+
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_search:
	push r20
	push r21
	clr  r1
	clr  r20
	ld   r26,y
	ldd  r27,y+1
__w1_search0:
	mov  r0,r1
	clr  r1
	rcall _w1_init
	tst  r30
	breq __w1_search7
	ldd  r30,y+2
	st   -y,r30
	rcall _w1_write
	ldi  r21,1
__w1_search1:
	cp   r21,r0
	brsh __w1_search6
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search2
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search3
	rcall __sel_bit
	and  r24,r25
	brne __w1_search3
	mov  r1,r21
	rjmp __w1_search3
__w1_search2:
	rcall __w1_read_bit
__w1_search3:
	rcall __sel_bit
	and  r24,r25
	ldi  r23,0
	breq __w1_search5
__w1_search4:
	ldi  r23,1
__w1_search5:
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search6:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search9
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search8
__w1_search7:
	mov  r30,r20
	pop  r21
	pop  r20
	adiw r28,3
	ret
__w1_search8:
	set
	rcall __set_bit
	rjmp __w1_search4
__w1_search9:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search10
	rjmp __w1_search11
__w1_search10:
	cp   r21,r0
	breq __w1_search12
	mov  r1,r21
__w1_search11:
	clt
	rcall __set_bit
	clr  r23
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search12:
	set
	rcall __set_bit
	ldi  r23,1
	rcall __w1_write_bit
__w1_search13:
	inc  r21
	cpi  r21,65
	brlt __w1_search1
	rcall __w1_read_bit
	rol  r30
	rol  r30
	andi r30,1
	adiw r26,8
	st   x,r30
	sbiw r26,8
	inc  r20
	tst  r1
	breq __w1_search7
	ldi  r21,9
__w1_search14:
	ld   r30,x
	adiw r26,9
	st   x,r30
	sbiw r26,8
	dec  r21
	brne __w1_search14
	rjmp __w1_search0

__sel_bit:
	mov  r30,r21
	dec  r30
	mov  r22,r30
	lsr  r30
	lsr  r30
	lsr  r30
	clr  r31
	add  r30,r26
	adc  r31,r27
	ld   r24,z
	ldi  r25,1
	andi r22,7
__sel_bit0:
	breq __sel_bit1
	lsl  r25
	dec  r22
	rjmp __sel_bit0
__sel_bit1:
	ret

__set_bit:
	rcall __sel_bit
	brts __set_bit2
	com  r25
	and  r24,r25
	rjmp __set_bit3
__set_bit2:
	or   r24,r25
__set_bit3:
	st   z,r24
	ret

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LTB12U:
	CP   R26,R30
	LDI  R30,1
	BRLO __LTB12U1
	CLR  R30
__LTB12U1:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
